a = [1,2,3]
puts "a is of type #{a.class}"		# string interpolation!

# Arrays are normally indexed 0-based
for i in (0...a.size)
	puts "a[#{i}]  =  #{a[i]}"
end

# Arrays can be indexed backwards with negative numbers (1-based)
for i in (-a.size..-1) 
	puts "a[#{i}]  =  #{a[i]}"
end

# Iterating by while loop
print "\nIterating over array a: "
i = 0
while i < a.length
  puts a[i]
  i = i+1
end

# Iterating by code block
print "\nIterating over array a (code block): "
a.each { |x|
  puts x
}

# push/pop adds/removes at end
a.push("a")
x = a.pop

# unshift/shift adds/removes at beginning
a.unshift("b")
y = a.shift

# assigning out of bounds extends the array
# (puts nil in unassigned, extra places)
puts "before: #{a.inspect}"
a[4] = 5
puts "after: #{a.inspect}"

print "\nIterating over array a: "
3.times { |i|
	print a[i], " "
}
print "\n"
